﻿'use strict'

var stateReady = false;

var storeId;
var keyCd;
var dataJSON;
var dataCSV;
var pageAmount;


const scriptCode =
  `(function() {
    })();`;


// ポップアップを開いたときの処理
chrome.tabs.executeScript({code: scriptCode}, function(result) {
//chrome.tabs.executeScript(function(result) {

    chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
		if (stateReady == false) {
			stateReady = true;
	        chrome.tabs.sendMessage(tabs[0].id, {
	            action: '1'
	        },
	        function(msg) {
			    chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
			        chrome.tabs.sendMessage(tabs[0].id, {
			            action: '2'
			        },
			        function(msg) {
						 var val = msg.split(',');
						 storeId = val[0];
						 keyCd = val[1];
						 getData(0, 1, 0, 1);
			        });
			    });
	        });
		}
    });

});


// サーバからデータを取得する
var getData = function(opt, sortItem, order, page) {

	// XMLHttpRequest の設定
	var xhr = new XMLHttpRequest();
	xhr.open("POST", "https://airregi.jp/CLP/api/customerManager/readList/", true);
	xhr.onreadystatechange = function () {
		if (xhr.readyState == 4) {
			dataJSON = JSON.parse(xhr.responseText);
			dataCSV = makeCSV(dataJSON.results.resultsData.customerList);
			if (opt == 0) {
				pageAmount = dataJSON.results.resultsData.totalPageCnt;
				makePager(pageAmount);
			}
			if (opt == 1) {
				downloadFile(dataCSV, "customerList.csv");
			}
		}
	};
	xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	xhr.setRequestHeader("corClpKeyCd", keyCd);
	xhr.setRequestHeader("X-Requested-With", "XMLHttpRequest");

	// リクエストパラメータ
	var param = {
		"storeId": storeId,
		"visStoreNumFrom": "",
		"visStoreNumTo": "",
		"birthdayMm": "",
		"sexCd": "",
		"ageFrom": "",
		"ageTo": "",
		"lastVisDateFrom": "",
		"lastVisDateTo": "",
		"regDateFrom": "",
		"regDateTo": "",
		"updDateFrom": "",
		"updDateTo": "",
		"customerNo": "",
		"sei": "",
		"mei": "",
		"tel": "",
		"email": "",
		"prefCd": "",
		"address": "",
		"sortItem": "" + sortItem,
		"order": "" + order,
		"nowPage": page
	};
	var json = JSON.stringify(param);

	// リクエストの開始
	xhr.send("paramStr=" + json);


	// CSVデータの作成
	function makeCSV(obj) {
		var csvData = '';
		var header = new Array();
		var values = new Array();

		// ヘッダを作成する
		header[0] = 'storeId';
		header[1] = 'customerId';
		header[2] = 'customerNo';
		header[3] = 'sei';
		header[4] = 'mei';
		header[5] = 'seiKana';
		header[6] = 'meiKana';
		header[7] = 'mailAddress';
		header[8] = 'mailAddress2';
		header[9] = 'tel';
		header[10] = 'lastVisDate';
		header[11] = 'visStoreNum';
		header[12] = 'version';

		for (var i = 0; i < obj.length; i ++) {
			// 行を初期化する
			values[i] = new Array();
			for (var k = 0; k < header.length; k ++) {
				values[i][k] = '';
			}

			// 値を代入する
			for (name in obj[i]) {
				for (var k = 0; k < header.length; k ++) {
					if (header[k] == name) {
						values[i][k] = obj[i][name];
					}
				}
			}
		}

		// CSVデータの作成
		for (var i = 0; i < header.length; i ++) {
			csvData += "\"" + header[i] + "\"";
			if (i != header.length - 1) {
				csvData += ",";
			}
		}
		csvData += "\n";
		for (var i = 0; i < values.length; i ++) {
			for (var k = 0; k < values[i].length; k ++) {
				csvData += "\"" + values[i][k] + "\"";
				if (k != header.length - 1) {
					csvData += ",";
				}
			}
			csvData += "\n";
		}

		return (csvData);
	};

	// ページャの作成
	function makePager(amount) {
		var options = new Array();
		for (var i = 0; i < amount; i ++) {
			options[i] = document.createElement('option');
			var tmp = i + 1;
			options[i].value = "" + tmp;
			options[i].innerText = "" + tmp + " ページ";
			document.getElementById("page").appendChild(options[i]);
		}

		var a = document.createElement('a');
	};

	// ファイルのダウンロード
	function downloadFile(content, filename) {
		var a = document.createElement('a');
		var bom = new Uint8Array([0xEF, 0xBB, 0xBF]);
		var blob = new Blob([bom, content], {"type" : "text/csv"});
		a.download = filename;
		a.href = window.URL.createObjectURL(blob);
		a.click();
	};

};


// ダウンロードボタン押下時の処理
var downloadButton = document.getElementById('download_button');
downloadButton.onclick = function() {

	var sortItem;
	var order;
	var page;

	sortItem = document.getElementById("sortItem").value;
	order = document.getElementById("order").value;
	page = document.getElementById("page").value;

	getData(1, sortItem, order, page);

}


// リファラの書き換え
chrome.webRequest.onBeforeSendHeaders.addListener(
	function (details) {
		//フラグ変数
		var refererFound = false;
		for (var i = 0; i < details.requestHeaders.length; i++) {
			var header = details.requestHeaders[i];
			if (header.name == "Referer") {
				//リファラがairregi.jpでなければ書き換える
				header.value = "https://airregi.jp/";
				refererFound = true;
				break;
			}
		}
		//リファラなしの場合は追加
		if (!refererFound) {
			details.requestHeaders.push({
				name: "Referer",
				value: "https://airregi.jp/"
			});
		}
		//書き換えたヘッダを返却
		return {requestHeaders: details.requestHeaders};
	},
	{
		urls: ["*://*/*"],
		types: [
			"main_frame",
			"sub_frame",
			"xmlhttprequest"
		]
	},
	[
		"requestHeaders",
		"blocking"
	]
);


//EOF